#!/bin/sh
#!
# @file preinstall
# @author Sobal
# @date 2016/12/14
#

UninstallDir()
{
    if [ -e "${1}" ] ; then
        sudo rm -R "${1}"
    fi
}

Uninstall()
{
    if [ -e "${1}" ] ; then
        sudo rm "${1}"
    fi
}

KillService()
{
    local plistFullName="${1}"
    local dirName=$(dirname ${plistFullName})
    local plistFileName=$(basename ${plistFullName})
    local nonExtFileName=${plistFileName%.*}

    if [ -e ${plistFullName} ] ; then
        cd ${dirName}
        sudo launchctl stop ${nonExtFileName}
        cd "/"
        sudo rm ${plistFullName}
    fi
}

UnloadService()
{
    local plistFullName="${1}"
    if [ -e ${plistFullName} ] ; then
        sudo launchctl unload ${plistFullName}
        sudo rm ${plistFullName}
    fi
}


KillApplication()
{
    Count=`ps -ef | grep "${1}" | grep -v grep | wc -l`
    if [ 0 -ne ${Count} ] ; then
        pkill -term -f "${1}"
    fi
}

#!
# @brief 登録済み証明書の削除
#
UnregisterFromSystemKeychain()
{
#    SCRIPT_DIR=$(cd $(dirname $(readlink $0 || echo $0)); pwd)
    SCRIPT_DIR=$(dirname "${0}")
    UNREG_TOOL="${SCRIPT_DIR}/UnregSSLCertKey"
    CERT_SHA1=3D230583898416B2815D5D7E738C6FAC6273A8E3
    SYS_KEYCHAIN_PATH=/Library/Keychains/System.keychain

    echo "Unregister SSL Certificate/Key from System KeyChain.."
    sudo "$UNREG_TOOL" -Z $CERT_SHA1 -t $SYS_KEYCHAIN_PATH >&1
}

cd "/"
KillApplication "PowerAttendant Lite"
KillApplication "AgentTrayIcon"

KillService "/Library/LaunchDaemons/jp.co.omron.powerattendant.AgentDaemon.plist"
UnloadService "/Library/LaunchDaemons/jp.co.omron.powerattendant.AgentService.plist"
KillService "/Library/LaunchAgents/jp.co.omron.powerattendant.AgentTrayIcon.plist"

sleep 5s

UninstallDir "/usr/local/bin/OMRON/PAL"
UninstallDir "/private/var/lib/OMRON/PAL"
UninstallDir "/Applications/PowerAttendant Lite.app"
UnregisterFromSystemKeychain

echo "PowerAttendant Lite Uninstaller completed.."
